diff -x po -ur apt-0.7.19/apt-pkg/acquire-item.cc apt-0.7.19.new/apt-pkg/acquire-item.cc
--- apt-0.7.19/apt-pkg/acquire-item.cc	2008-11-24 09:32:23.000000000 +0000
+++ apt-0.7.19.new/apt-pkg/acquire-item.cc	2009-01-02 20:15:04.000000000 +0000
@@ -563,7 +563,9 @@
    if(comprExt.empty()) 
    {
       // autoselect the compression method
-      if(FileExists("/bin/bzip2")) 
+      if(FileExists("/usr/bin/lzma")) 
+	 CompressionExtension = ".lzma";
+      else if(FileExists("/bin/bzip2")) 
 	 CompressionExtension = ".bz2";
       else 
 	 CompressionExtension = ".gz";
@@ -598,8 +600,16 @@
 void pkgAcqIndex::Failed(string Message,pkgAcquire::MethodConfig *Cnf)
 {
    bool descChanged = false;
+   // no .lzma found, retry with .bz2
+   if(Desc.URI.substr(Desc.URI.size()-4) == "lzma") {
+     Desc.URI = Desc.URI.substr(0,Desc.URI.size()-4) + "bz2";
+
+      new pkgAcqIndex(Owner, RealURI, Desc.Description,Desc.ShortDesc,
+		      ExpectedHash, string(".bz2"));
+	  descChanged = true;
+   }
    // no .bz2 found, retry with .gz
-   if(Desc.URI.substr(Desc.URI.size()-3) == "bz2") {
+   else if(Desc.URI.substr(Desc.URI.size()-3) == "bz2") {
       Desc.URI = Desc.URI.substr(0,Desc.URI.size()-3) + "gz";
 
       new pkgAcqIndex(Owner, RealURI, Desc.Description,Desc.ShortDesc,
@@ -713,7 +723,9 @@
    
    string compExt = flExtension(flNotDir(URI(Desc.URI).Path));
    const char *decompProg;
-   if(compExt == "bz2") 
+   if(compExt == "lzma")
+      decompProg = "lzma";
+   else if(compExt == "bz2")
       decompProg = "bzip2";
    else if(compExt == "gz") 
       decompProg = "gzip";
diff -x po -ur apt-0.7.19/ftparchive/writer.cc apt-0.7.19.new/ftparchive/writer.cc
--- apt-0.7.19/ftparchive/writer.cc	2008-06-09 21:10:09.000000000 +0000
+++ apt-0.7.19.new/ftparchive/writer.cc	2009-01-02 19:41:21.000000000 +0000
@@ -815,9 +815,11 @@
    AddPattern("Packages");
    AddPattern("Packages.gz");
    AddPattern("Packages.bz2");
+   AddPattern("Packages.lzma");
    AddPattern("Sources");
    AddPattern("Sources.gz");
    AddPattern("Sources.bz2");
+   AddPattern("Sources.lzma");
    AddPattern("Release");
    AddPattern("md5sum.txt");
 
